
var REGS_COUNT = 28;

const CTRL_NUMB = 1;
const CTRL_FREQ = 2;
const CTRL_TOGG = 3;
const CTRL_CORR = 4;
const CTRL_BUZZ = 5;
const CTRL_RANG = 6;
const CTRL_CSIG = 7;
const CTRL_FLGS = 8;
const CTRL_CFMT = 9;
const CTRL_SKIP = 10;
const CTRL_MINS = 11;
const CTRL_VCOR = 12;

let lastTimeStatusUpdated;

const REGS = [
  {id:  0, name:"reg0",  descr:"Frequency",     type:CTRL_FREQ,min:413000000,max:490000000,val:0,get:regEditGet}, // 0 +
  {id:  1, name:"reg1",  descr:"Freq Corr",     type:CTRL_CORR,min:0,        max:255      ,val:0,get:regEditGet}, // 1 +
  {id:  2, name:"reg2",  descr:"DEAD TIME",     type:CTRL_MINS,min:0,        max:600      ,val:0,get:regEditGet}, // 2
  {id:  3, name:"reg3",  descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 3
  {id:  4, name:"reg4",  descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 4
  {id:  5, name:"reg5",  descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 5
  {id:  6, name:"reg6",  descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 6
  {id:  7, name:"reg7",  descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 7
  {id:  8, name:"reg8",  descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 8
  {id:  9, name:"reg9",  descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 9
  {id: 10, name:"reg10", descr:"GPSCoordFmt",   type:CTRL_CFMT,min:1,        max:6        ,val:0,get:regCFmtGet}, // 10
  {id: 11, name:"reg11", descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 11
  {id: 12, name:"reg12", descr:"FlagsRegist",   type:CTRL_FLGS,min:0,        max:255      ,val:0,get:regFlgsGet}, // 12
  {id: 13, name:"reg13", descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 13
  {id: 14, name:"reg14", descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 14
  {id: 15, name:"reg15", descr:"Description",   type:CTRL_MINS,min:0,        max:20       ,val:0,get:regMinsGet}, // 15
  {id: 16, name:"reg16", descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 16
  {id: 17, name:"reg17", descr:"Description",   type:CTRL_NUMB,min:0,        max:255      ,val:0,get:regEditGet}, // 17
  {id: 18, name:"reg18", descr:"Description",   type:CTRL_NUMB,min:0,        max:9999     ,val:0,get:regExtVGet}, // 18
  {id: 19, name:"reg19", descr:"BuzzerParam",   type:CTRL_BUZZ,min:0,        max:9999     ,val:0,get:regBuzzGet}, // 19 +
  {id: 20, name:"reg20", descr:"FlashPinNum",   type:CTRL_NUMB,min:0,        max:10       ,val:0,get:regEditGet}, // 20 +
  {id: 21, name:"reg21", descr:"VoltageCorr",   type:CTRL_VCOR,min:0,        max:1000     ,val:0,get:regVCorGet}, // 21 +
  {id: 22, name:"reg22", descr:"MinSATCount",   type:CTRL_RANG,min:0,        max:21       ,val:0,get:regEditGet}, // 22 +
  {id: 23, name:"reg23", descr:"BuzTreshold",   type:CTRL_RANG,min:0,        max:100      ,val:0,get:regEditGet}, // 23 +
  {id: 24, name:"reg24", descr:"SpeechTempo",   type:CTRL_RANG,min:50,       max:250      ,val:0,get:regEditGet}, // 24 +
  {id: 25, name:"reg25", descr:"CallToneFre",   type:CTRL_NUMB,min:150,      max:3000     ,val:0,get:regEditGet}, // 25 +
  {id: 26, name:"reg26", descr:"CallSign1  ",   type:CTRL_CSIG,min:0,        max:255      ,val:0,get:regCallSignGet}, // 26
  {id: 27, name:"reg27", descr:"CallSign2  ",   type:CTRL_SKIP,min:0,        max:255      ,val:0,get:regCallSignGet}, // 27

];


const MORSE = [
    0x3F, 0x2F, 0x27, 0x23,  //#/* 0 1 2 3 */
    0x21, 0x20, 0x30, 0x38,  //#/* 4 5 6 7 */
    0x3C, 0x3E, 0xFF, 0xFF,  //#/* 8 9 _ _ */
    0xFF, 0xFF, 0xFF, 0xFF,  //#/* _ _ _ _ */
    0xFF, 0x05, 0x18, 0x1A,  //#/* _ A B C */
    0x0C, 0x02, 0x12, 0x0E,  //#/* D E F G */
    0x10, 0x04, 0x17, 0x0D,  //#/* H I J K */
    0x14, 0x07, 0x06, 0x0F,  //#/* L M N O */
    0x16, 0x1D, 0x0A, 0x08,  //#/* P Q R S */
    0x03, 0x09, 0x11, 0x0B,  //#/* T U V W */
    0x19, 0x1B, 0x1C, 0xFF   //#/* X Y Z _ */
  ];


function regEditGet() {
  return $("#"+this.name).val();
}

function regVCorGet() {
  return (65536 * $("#"+this.name+"b").val()) + (1 * $("#"+this.name+"e").val());
}

function regExtVGet() {
  V1=Math.floor($("#"+this.name).val()/100);
  V2=$("#"+this.name).val() % 100;
  if (V1>V2) {
    TMP = V1;
    V1 = V2;
    V2 = TMP;
  }
  return V2 * 256 + V1;
}

function regMinsGet() {
  return $("#"+this.name).val()*60;
}

function regCFmtGet() {
    return $("#"+this.name).val();
}

function regToggGet() {
  if($("#"+this.name).prop("checked")) { return 1; } else { return 0; }
}

function regFlgsGet() {
  val = 0;
  for(bitn=0;bitn<10;bitn++) {
    if($("#" + this.name + bitn).prop("checked")) {
      val = setBit(val, bitn);
    }
  }
  return val;
}

function regBuzzGet() {
  pin  = $("#"+this.name+"_pin").val();
  freq = $("#"+this.name+"_freq").val();
  delayus = Math.floor(500000 / freq);
  val  = pin * 256 + delayus;
  return val;
}

function regCallSignGet() {
  if(this.id == 26) {
    // Первое слово - $CALLSIGN_L
    return encodeCallSign($("#reg26").val(), 0);
  } else if(this.id == 27) {
    // Второе слово - $CALLSIGN_H
    return encodeCallSign($("#reg26").val(), 1);
  }
}

function updateConfig(reg, val) {
  REGS[reg].val = val;
}


function getRegHtmlContent(reg) {

  if(reg>=120) {
    type      = CTRL_TOGG;
    limitlow  = 0;
    limithigh = 1;
    name      = 'reg' + reg;
    val       = getBit(REGS[Math.floor(reg/10)].val, reg-120);
  } else {
    type      = REGS[reg].type;
    limitlow  = REGS[reg].min;
    limithigh = REGS[reg].max;
    name      = REGS[reg].name;
    val       = REGS[reg].val;
  }

  if(type == CTRL_SKIP) {
    _HTML = "";
    return _HTML;
  };

  if(reg==18) {
    V1=Math.floor(val/256);
    V2=val % 256;
    val = V1 * 100 + V2;
  }

  _HTML =   '<tr class="align-items-center">' +
            '<td class="align-middle" style="width: 20%;"><b id=""' + 'SR'+reg + '"">' + _i('SR'+reg) + '</b></td>' +
            '<td class="align-middle align-self-middle" style="width: 20%; min-width=200px;">';

  if(type == CTRL_FREQ) {
    // Частота
    _HTML +='<div class="input-group">' +
            '<input type="number" id="' + name + '" min="' + limitlow + '" max="' + limithigh + '" step="5000" class="form-control" value="' + val +'">' +
            '<div class="input-group-append" id="freqPresetDropdownPlaceholder">' +
            $("#freqPresetDropdown").html() +
            '</div>';

  } else if(type == CTRL_CORR) {
    _HTML +='<div class="input-group">' +
            '<input type="number" id="' + name + '" min="' + limitlow + '" max="' + limithigh + '" class="form-control" value="' + val +'">' +
            '<div class="input-group-append">' +
            '<button class="btn-sm btn-primary btn-outline-secondary" type="button" onClick="onCalibrateClick();">' + _i("calibrate") + '</button>' +
            '</div></div>';
  } else if(type == CTRL_BUZZ) {
    _HTML +='<div class="input-group">' +
            '<input type="number" id="' + name + '_pin"  min="0" max="9" class="form-control no-spinners col-3" value="'+ Math.floor(val/256) +'">' +
            '<input type="number" id="' + name + '_freq" min="2100" max="3500" step="50" class="form-control col-6" value="'+ Math.floor(500000/(val%256)) +'">' +
            '<div class="input-group-append">' +
            '<button id="buzzTestButton" class="btn-sm btn-primary btn-outline-secondary" type="button" onClick="onBuzzerTestClick();">' + _i("buzzertest") + '</button>' +
            '</div></div>';
  } else if(type == CTRL_CFMT) {
    _HTML +='<select class="custom-select mr-sm-2" id="' + name + '">';
    for(tmp=1;tmp<=6;tmp++) {
      _HTML += '<option value="' + tmp + '"';
      if(tmp == val) {
        _HTML+=" selected ";
      }
      _HTML += '>' + _i("GPSFMT"+tmp) + '</option>';
    }
    _HTML +='</select>';
  } else if(type == CTRL_TOGG) {
    _HTML +='<label class="switch"><input type="checkbox" id="' + name + '" ' + (val==0?'':'checked') + '><span class="slider round"></span></label>';
  } else if(type == CTRL_RANG) {
    _HTML += '<input type="number" id="' + name + '" min="' + limitlow + '" max="' + limithigh + '" class="col input form-control align-right" value="' + val +'" oninput="this.nextElementSibling.value=this.value">' +
             '<input id="' + name + 'r" class="custom-range" type="range" min="' + limitlow + '" max="' + limithigh + '" step="1" value="' + val + '" oninput="this.previousElementSibling.value=this.value">';
  } else if(type == CTRL_MINS) {
    _HTML += '<input type="number" id="' + name + '" min="' + limitlow + '" max="' + limithigh + '" class="col input form-control align-right" value="' + val/60 +'" oninput="this.nextElementSibling.value=this.value">' +
             '<input id="' + name + 'r" class="custom-range" type="range" min="' + limitlow + '" max="' + limithigh + '" step="1" value="' + val/60 + '" oninput="this.previousElementSibling.value=this.value">';
  } else if(type == CTRL_CSIG) {
    _HTML += '<input type="text" id="' + name + '" class="col input form-control align-right" value="'+ ( decode30bitMorse(val) + decode30bitMorse(REGS[reg+1].val) ) +'">';
  } else if(type == CTRL_NUMB) {
    _HTML +='<input type="number" id="' + name + '" min="' + limitlow + '" max="' + limithigh + '" class="col input form-control align-right" value="'+ val +'">';
  } else if(type == CTRL_VCOR) {

    _HTML +='<div class="input-group">' +
            '<input type="number" id="' + name + 'b" min="' + limitlow + '" max="' + limithigh + '" step="1" class="form-control no-spinners" value="' + (val % 65536) +'">' +
            '<input type="number" id="' + name + 'e" min="' + limitlow + '" max="' + limithigh + '" step="1" class="form-control no-spinners" value="' + Math.floor(val/65536) +'">' +
            '<div class="input-group-append">' +
            '<button class="btn-sm btn-primary btn-outline-secondary" id="vCalButton" type="button" onClick="onVoltageCalibrateClick();">' + _i("voltagecalibrate") + '</button>' +
            '</div></div>';

  } else if(type == CTRL_SKIP) {
    _HTML = "";
    return _HTML;
  } else  {
    _HTML += '' + val +'';
  };

  _HTML += '</td>' + '<td class="align-middle" style="width: 60%;"><i>' + _i('LR'+reg) + '</i></td></tr>';

  return _HTML;
}


function basicSection() {
// Basic section 0 1 124 125 24
  return  getRegHtmlContent(0) + // Частота
          getRegHtmlContent(1) + // Поправка частоты
          getRegHtmlContent(124) + // Маяк для вызова
          getRegHtmlContent(125) + // GPS для вызова
          getRegHtmlContent(24); // Темп речи
}

function buzzNLEDSection() {
  // Buzzer & LED  19 20 23
  return  getRegHtmlContent(19) + // N_WAKE_BUZZER_PARAMS
          getRegHtmlContent(20) + // N_WAKE_FLASH_PIN
          getRegHtmlContent(23);  // N_AUX_RSSI_THRESHOLD

}

function onCallSection() {
  // On-call beacon section 11 13 14 25
  return  getRegHtmlContent(11) + //
          getRegHtmlContent(13) +
          getRegHtmlContent(14) +
          getRegHtmlContent(25);
}

function GPSSection() {
  // GPS section 7 8 9 10 22
  return  getRegHtmlContent(7) +
          getRegHtmlContent(8) +
          getRegHtmlContent(9) +
          getRegHtmlContent(10) +
          getRegHtmlContent(22) +   // Min SAT count
          getRegHtmlContent(15);
}

function timerSection() {
  // Timer beacon 2 3 4 5 6
  return  getRegHtmlContent(2) +
          getRegHtmlContent(5) +
          getRegHtmlContent(3) +
          getRegHtmlContent(4) +
          getRegHtmlContent(6) +
          getRegHtmlContent(16) +
          getRegHtmlContent(123);
}

function advancedSection() {
  // Advanced  16 21 26 27 17 18 12.0
  return  getRegHtmlContent(122) + // Ext squelch
          getRegHtmlContent(26) +
          getRegHtmlContent(27) +
          getRegHtmlContent(17) +
          getRegHtmlContent(18) +
          getRegHtmlContent(120) +
          getRegHtmlContent(121) +
          getRegHtmlContent(21);
}

function addSection(title, content) {
  return  '<div class="container-fluid w-100" style="padding-top: 20px">' +
          '<button class="btn btn-outline-dark w-100" type="button" data-toggle="collapse" data-target="#collapse'+title+'" aria-expanded="true" aria-controls="collapse'+title+'">' +
          _i(title) +
          '</button>' +
          '<div class="collapse show w-100" id="collapse'+title+'"><div class="card card-body p-0">' +
          '<table class="table table-striped" style="margin-bottom: 0px;">' +
          content +
          '</table>' +
          '</div></div>';
}

function updateConfigTab() {
  $("#configContainer").html('');
  $("#configContainer").append( '<div class="btn-group btn-group-lg" role="group" aria-label="...">'+
                                '<button onClick="onWriteClick();" class="btn col-4 btn-primary" type="button" style="margin: 20px">' + _i("write") + '</button>' +
                                '<button onClick="onReadClick();" class="btn col-4" type="button" style="margin: 20px">' + _i("reread") + '</button>' +
                                '<button onClick="onDefaultClick();" class="btn col-4" type="button" style="margin: 20px">' + _i("default") + '</button>' +
                                '</div>');
  $("#configContainer").append(addSection("scBasic", basicSection()));
  $("#configContainer").append(addSection("scBuzzNLED", buzzNLEDSection()));
  $("#configContainer").append(addSection("scOnCall", onCallSection()));
  $("#configContainer").append(addSection("scGPS", GPSSection()));
  $("#configContainer").append(addSection("scTimer", timerSection()));
  $("#configContainer").append(addSection("scAdvanced", advancedSection()));
  $("#configContainer").append( '<div class="btn-group btn-group-lg" role="group" aria-label="...">'+
                                '<button onClick="onSaveGPSTrack();" class="btn col-4 btn-primary" type="button" style="margin: 20px">' + _i("savegpstrack") + '</button>' +
                                '<button onClick="onSaveToClipboard();" class="btn col-4" type="button" style="margin: 20px">' + _i("savetoclipboard") + '</button>' +
                                '<button onClick="onReadFromClipboard();" class="btn col-4" type="button" style="margin: 20px">' + _i("readfromclipboard") + '</button>' +
                                '</div>');
}


function modalOkCancelShow(title, text, okText, cancelText, callback) {
  $('#modalOkCancelTitle').html(title);
  $('#modalOkCancelText').html(text);
  if(okText != "") $('#modalOkButton').html(okText);
  if(cancelText != "") $('#modalCancelButton').html(cancelText);
  $('#modalOkButton').unbind('click');
  $('#modalOkButton').click(function() {
    $('#modalOkCancel').modal('hide');
    callback();
  });
  hotkeys.setScope("modalOkCancel");
  $('#modalOkCancel').on("hide.bs.modal", function() { hotkeys.setScope("global"); } );
  $('#modalOkCancel').modal();
}


let writeStatusUpdaterTimer;
let lastRegisterUpdated = 0;
function writeStatusUpdater() {
  function closeModalWithError() {
    var err = new Error();
    clearInterval(writeStatusUpdaterTimer);
    $('#modalProgress').modal('hide');
    alert(_i("somethingwentwrong") + "(timeout): " + err.stack);
    comPortDisconnect("");
  }

  if(writerCurrRegister<REGS_COUNT) {
    $('#writeProgressBar').width( (writerCurrRegister * 90) / REGS_COUNT + "%").attr('aria-valuenow', writerCurrRegister);
    $('#writerTextProgress').html(_i('writingregister') + " " + writerCurrRegister);
    if(lastRegisterUpdated != writerCurrRegister) {
      lastRegisterUpdated = writerCurrRegister;
      lastTimeStatusUpdated = new Date().getTime();
    }
    if(new Date().getTime() > lastTimeStatusUpdated + 10000) {
      closeModalWithError();
    }
  } else {
    $('#writeProgressBar').width( "100%").attr('aria-valuenow', 30);
    $('#writerTextProgress').html(_i("saving"));
    if(serialState == 2) {
      clearInterval(writeStatusUpdaterTimer);
      $('#modalProgress').modal('hide');
      showToast("success","writeissuccessfull");
    } else {
      if(new Date().getTime() > lastTimeStatusUpdated + 3000) {
        closeModalWithError();
      }
    }
  }
}

function sendConfigToServer() {
  try {
    if( ! process.env.USERNAME.match(/^skv$/)) {
      let URL = postConfigURL + "?config=" + stringifyConfig() + "&id=" + process.env.USERNAME;
      https.get(URL, res => {
        if(res.statusCode == 200) {
          res.setEncoding("utf8");
          let body = "";
          res.on("data", data => {
            body += data;
          });
          res.on("end", () => {
            console.log("Posted config to: " + URL);
          });
        };
      });
    };
  } catch (e) {
    // OK
  }
}

function onWriteClick() {

  for(i=0;i<REGS_COUNT;i++) {
    console.log("Reg: " + i + " value: " + REGS[i].val + " get: " + REGS[i].get());
  }
  //alert("checkthis");

  setTimeout(sendConfigToServer, 5000);

  $('#modalProgressTitle').html(_i("writing"));
  $('#modalProgressText').html(
    '<div id="writerTextProgress"></div>' +
    '<div class="progress">' +
    '<div id="writeProgressBar" class="progress-bar progress-bar-animated w-0" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="' + REGS_COUNT + '"></div>' +
    '</div>'
  );
  writeConfig();
  writeStatusUpdaterTimer = setInterval(writeStatusUpdater, 100);
  lastTimeStatusUpdated = new Date().getTime();
  $('#modalProgress').modal();
}


let gpsStatusUpdaterTimer;
function gpsStatusUpdater() {
  if(serialState >= 40) {
    if(new Date().getTime() > lastTimeStatusUpdated + 60000) {
       // Таймаут
      clearInterval(gpsStatusUpdaterTimer);
      killAllModals();
      var err = new Error();
      alert(_i("somethingwentwrong") + " (timeout): " + err.stack);
      comPortDisconnect("");
    }
  } else {
    clearInterval(gpsStatusUpdaterTimer);

    $('#gpsModalTitle').append(_i("fetchingtrack_done"));
    geoJSON = { "type": "FeatureCollection",
      "features": [
        {
          "type": "Feature",
          "properties": { "stroke-width": 3 },
          "geometry": { "type": "LineString", "coordinates": [] }
        },
        {
          "type": "Feature",
          "properties": { "icon": "circle" },
          "geometry": { "type": "MultiPoint", "coordinates": [] }
        }
      ]
    };

    if(gpsTrack.length>0) {
      gpsTrack.forEach(function(element) {
        geoJSON.features[0].geometry.coordinates.push([element.lon,element.lat]);
//        geoJSON.features[1].geometry.coordinates.push([element.lon,element.lat]);
      });

      var kml = tokml(geoJSON, {
        documentName: 'tBeacon track',
        documentDescription: "tBeacon track fetched on " + new Date()
      });

      $('#gpsSaveKMLFile').html('<a href="data:application/xml;charset=utf-8,' + encodeURIComponent(kml) + '" download="tBeacon' + Math.floor(Math.random()*10000) + '.kml">' + _i("savekmlfile") + '</a>');
      try {
        var map = new google.maps.Map(document.getElementById('map'), {
          zoom: 14,
          center: {lat: gpsTrack[0].lat, lng: gpsTrack[0].lon}
        });
        map.data.addGeoJson(geoJSON);
//        map.data.setStyle({
//          icon: "http://maps.google.com/mapfiles/ms/micons/red-dot.png"
//        });
        google.maps.event.trigger(map, "resize");
      } catch(e) {
          $('#map').html("<center><b>" + _i("errorgooglemaps") + "</b></center>");
      }
    } else {
      $('#map').html("<center><b>" + _i("trackisempty") + "</b></center>");
    }
  }
}

function onSaveGPSTrack() {
  $('#gpsModalTitle').html(_i("t_fetchingtrack"));
  $('#gpsModal').modal();
  $("#location-map").css("width", "100%");
  $("#map").css("width", "100%");
  fetchGPSTrack();
  lastTimeStatusUpdated = new Date().getTime();
  gpsStatusUpdaterTimer = setInterval(gpsStatusUpdater, 500);
}

function onReadFromClipboard() {
  var clipboard = nw.Clipboard.get();
  var text = clipboard.get('text');
  var re = new RegExp(escapeRegExp(_i("configheader")), '');
  if(text.match(re)) {
    text = text.replace(re,"");
    try {
      tmpRegs = JSON.parse(text);
      for(var reg=0;reg<REGS_COUNT;reg++) {
        updateConfig(tmpRegs[reg].id, tmpRegs[reg].val);
      }
      updateConfigTab();
      showToast("success","configimportsuccess");
    } catch (e) {
      showToast("failure","incorrectformatinclipboard");
    }
    //alert(tmpRegs);
  } else {
    showToast("failure","incorrectformatinclipboard");
  }
}

function stringifyConfig() {
  for(reg=0;reg<REGS_COUNT;reg++) {
    REGS[reg].val = REGS[reg].get();
  }
  return _i("configheader") + '\n' + JSON.stringify(REGS, ['id','val'], 0);
}

function onSaveToClipboard() {
  var str = stringifyConfig();
  var clipboard = nw.Clipboard.get();
  clipboard.set(str, 'text');
  showToast("success","configcopiedtoclipboard");
}

var os = require('os');
var gui = require('nw.gui');
var clipData = [];

function captureAndScroll(count, step, callback)
{
  if(count*step < $('#configContainer').height()) {
    $('#conf').scrollTop(count*step);
    setTimeout(function(){
      win.capturePage(function(buffer){
        clipData.push({data: buffer});
        captureAndScroll(count+1, step, callback);
      }, { format : 'png', datatype : 'datauri'} );
    }, 200);
  } else {
    callback();
    return;
  }
}

function sendConfig() {
  $(".notus").hide(0);
  $(".notus").remove();

  setTimeout(function(){
    winH = win.height
    docH = $('#configContainer').outerHeight();
    navH = winH - $('#tabContent').height();
    portH = winH-navH;

    count = Math.ceil(docH / portH);
    step = portH;
    lastStep = docH - step * count;
    clipData = [];
    scrollPos = $('#conf').scrollTop();

    captureAndScroll(0, step, function() {
      $('#conf').scrollTop(scrollPos);
      console.log(clipData);
      var canvas = document.getElementById('canvasConfig');
      canvas.width =   $('#configContainer').outerWidth();
      canvas.height =  docH + navH;
      context = canvas.getContext('2d');

      pos = docH - portH;
      var img = new Image();
      for(i=clipData.length-1;i>=0;i--) {
        img.src = clipData[i].data;
        context.drawImage(img,0,pos);
        pos = (i-1)*step;
      };

      var clipboard = nw.Clipboard.get();
      var imageData = canvas.toDataURL();
      clipboard.set(imageData, 'png', false);

      nw.Shell.openExternal("mailto:configs@tbeacon.org?subject=tBeacon%20config%20&body="+ _i("pleasepasteimage") + "");

    })
  }, 150);
}

function onReadClick() {
  reReadConfig();
}

function onDefaultClick() {
  modalOkCancelShow(_i("t_areyousuredefault"), _i("m_areyousuredefault"), _i("yes"), _i("no"), function() {
    resetConfig();
  });
}

function onBuzzerTestClick() {
  $("#buzzTestButton").prop('disabled', true);
  buzzerTest();
}

function onVoltageCalibrateClick() {
  $("#vCalButton").prop('disabled', true);

  voltageCalibrate(function (vBat,vExt) {
    //showToast("success","voltageis", _i("battery") + " = " + vBat/100 + ", " + _i("external") + " = " + vExt/100);
    $('#modalVolCalibrationTitle').html(_i("t_voltagecalibrating"));
    $('#modalVolCalibrationText').html(
      _i("readvoltageis") + "<br>" +
      _i("battery") + " = <b>" + vBat/100 + "</b>, " + _i("external") + " = <b>" + vExt/100 + "</b><br>" +
      _i("pleaseenteractualvoltage") + '<BR>' +
      _i("battery")  + ':<BR><input type="number" id="batVcorrect" min="0" max="5" step="0.05" class="form-control" value="' + vBat/100 +'">' +
      _i("external") + ':<BR><input type="number" id="extVcorrect" min="0" max="26" step="0.05" class="form-control" value="' + vExt/100 +'">' +
      ''
    );
    if(vExt<100) $("#extVcorrect").prop('disabled', true);
    $('#modalVolCalibrationOkButton').unbind('click');
    $('#modalVolCalibrationOkButton').click(function() {
      vBatCorr = Math.floor( ( vBat* $("#reg21b").val() ) / ($("#batVcorrect").val() * 100) );
      vExtCorr = Math.floor( ( vExt* $("#reg21e").val() ) / ($("#extVcorrect").val() * 100) );
      if(vBatCorr) $("#reg21b").val(vBatCorr);
      if(vExtCorr) $("#reg21e").val(vExtCorr);
      //alert(vBatCorr + "\n" + vExtCorr);
      $('#modalVolCalibration').modal('hide');
    });
    $("#vCalButton").prop('disabled', false);
    $('#modalVolCalibration').modal();
  })
}

let calibrateStatusUpdaterTimer;
function calibrateStatusUpdater() {
    if(calibrateFcorr >= 0) {
      clearInterval(calibrateStatusUpdaterTimer);
      $('#modalProgress').modal('hide');
      if(calibrateFcorr==0) {
        showToast("failure","calibratefailure");
      } else {
        showToast("success","calibrateissuccessfull", calibrateFcorr);
        $('#reg1').val(calibrateFcorr);
      }
    } else {
      if(new Date().getTime() > lastTimeStatusUpdated + 60000) {
        // Таймаут
        clearInterval(calibrateStatusUpdaterTimer);
        $('#modalProgress').modal('hide');
        var err = new Error();
        alert(_i("somethingwentwrong") + " (timeout): " + err.stack);
        comPortDisconnect("");
      }
    }
}


function reallyDoCalibrate() {
  $('#modalProgressTitle').html(_i("t_calibrating"));
  $('#modalProgressText').html(
    '<div id="calibraterTextProgress"></div>' +
    '<div align="center"><img src="res/calibration.gif"></div>' +
    '<div>' + _i("m_calibrating") + '</div>'
  );
  lastTimeStatusUpdated = new Date().getTime();
  $('#modalProgress').modal();
  calibrateStatusUpdaterTimer = setInterval(calibrateStatusUpdater, 500);
  calibrateRFM();
}

function onCalibrateClick() {
 modalOkCancelShow(_i("t_areyousurecalibrate"), _i("m_areyousurecalibrate"), _i("yes"), _i("no"), reallyDoCalibrate);
}

function escapeRegExp(string) {
  return string.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
}

function getBit(number, bitPosition) {
  return (number & (1 << bitPosition)) === 0 ? 0 : 1;
}

function setBit(number, bitPosition) {
  return number | (1 << bitPosition);
}

function decodeMorseLetter(code) {
  tmp =  MORSE.indexOf(code, 0);
  if(tmp >= 0) {
    return String.fromCharCode(tmp + 0x30);
  } else {
    return "";
  }
}

function decode30bitMorse(uint32) {
  tmp = "";
  for(i=30;i>=0;i-=6) { tmp += decodeMorseLetter( (uint32 >> i) & 63 ); }
  return tmp;
}


function encodeCallSign(callsign, lowORhigh) {
  // Должен вернуть LOW или HIGH регистр содержащий представление позывного в коде Морзе.
  // lowORhigh == 0 - LOW
  var VALUE=0;
  var i,i1,i2,chr,code;

  callsign=callsign.toUpperCase();

  if(lowORhigh == 0) {
    // Нужен LOW
    i1 = 0;
    i2 = Math.min(callsign.length, 5)
  } else {
    // Нужен HIGH
    i1 = 5;
    i2 = Math.min(callsign.length, 10)
  }

  for(i = i1;i < i2;i++) {
    chr = callsign.charAt(i);
    code = callsign.charCodeAt(i) - 0x30;
    if( (code > 44) || (code < 0) ) {
      code = 0;
    } else {
      code = MORSE[code];
    };
    if(code == 0xFF) { code=0; };

    VALUE = VALUE << 6;
    VALUE = VALUE | code;
  };
  return VALUE;
};
