
var STK500 = require('stk500');
var series = require('run-series');
var intel_hex = require('intel-hex');
var fs = require('fs');
var async = require("async");


function scanFlashableHex() {
	fs.readdir("res/firmware/", function (err, files) {
    //handling error
    if (err) {
        return;
    }
    files.forEach(function (file) {
        if(file.search(".hex$")!=-1) {
					$('#hex-list').append($("<option/>", {
	            value: file,
	            text: file.replace(/.hex/i, '')
	        }));
					console.log("adding: " + file);
				} else {
					console.log("skipping: " + file);
				}
    });
	});
};

var flashingInProgress = false;

function stk500_log() {
	var s = arguments[0];
	lastLog = '';
	if (typeof s.message != 'undefined') {
		s = s.message;
	}

	for (i=0;i<arguments.length;i++) {
			lastLog += arguments[i] + ' ';
	}
	//$("#flashlog").append(s+'<BR>');
	if(s.search("sync complete") >= 0) {
		$("#flashlog").append(_i("f_ok"));
	} else if(s.search("sync failed") >= 0) {
		$("#flashlog").append(_i("f_syncfail"));
	} else if(s.search("sync") >= 0) {
		$("#flashlog").append(_i("f_syncing"));
	} else if(s.search("attempt") >= 0) {
		$("#flashlog").append(".");
	} else if(s.search("confirm signature") >= 0) {
		$("#flashlog").append(_i("f_signatureok"));
	} else if(s.search("program$") >= 0) {
		$("#flashlog").append(_i("f_programming"));
	} else if(s.search("^verify$") >= 0) {
		$("#flashlog").append(_i("f_veryfying"));
	} else if(s.search("^done$") >= 0) {
		$("#flashlog").append(_i("f_done"));
	} else if((s.search("page done") >= 0) ||
						(s.search("verified page") >= 0)) {
		$("#flashlog").append(".");

	} else if((s.search("load") >= 0) ||
						(s.search("verify") >= 0) ||
						(s.search("confirm") >= 0) ||
						(s.search("program") >= 0) ) {
		// Ingore it
	} else {
		console.log('lastlog:' + lastLog);
	}
};


function doFlash() {

	var curPort = $("#port-list").val();
	var curHex = $("#hex-list").val();

	//alert(_i("clickOKwhenready"));

	var data = fs.readFileSync('res/firmware/' + curHex, { encoding: 'utf8' });
	var hex = intel_hex.parse(data).data;
	var board = {
		signature: new Buffer([0x1e, 0x95, 0x0f]),
		pageSize: 128,
		timeout: 400,
		quiet: false
	}

	port = new serialPort.SerialPort(curPort, {
			baudrate: 115200,
			databits: 8,
			parity: "none",
			stopBits: 1,
			buffersize: 4096
		}, true,
		function (err) {

				chrome.serial.getConnections(function() { console.log(arguments) });
				console.log(port);

				sleep(1000);
				showToast('success',"flashing", curHex + " " + _i("via") + " " + curPort);

				if (err) {
					showToast('failure',erroropeningport);
					$("#btnConnect").prop('disabled', false);
					$("#port-list").prop('disabled', false);
					$("#btnFlash").prop('disabled', false);
					flashingInProgress = false;
					return;
				} else {
					$("#flashlog").html(_i("f_flashlog")+"<br>");

					chrome.serial.getInfo(port.connectionId, function(connectionInfo) {
						console.log('open');
						console.log(connectionInfo)
						var stk500 = new STK500(port);
						stk500.log = stk500_log;
						var lastLog = "";
						stk500.bootload(port, hex, board, function(error){
							if(error) {
								console.log(lastLog);
								console.log(error.message);
								$("#flashlog").append(_i("f_flashingfail") + error.message);
								showToast("failure","flashingfailed", error.message);
							} else {
								$("#flashlog").append(_i("f_flashingok"));
								showToast("success","flashingok");
							}
							$("#btnConnect").prop('disabled', false);
							$("#port-list").prop('disabled', false);
							$("#btnFlash").html(_i("flash"));

							flashingInProgress = false;
							lastTab = $("ul#tabs a.active");
							comPortDisconnect("");
							return;




							port.close(function (error) {
								port.removeAllListeners();

								port.options.serial.disconnect(port.connectionId,function (result) { console.log("SMTHWRNG: chrome.serial.disconnect: " + result); port = undefined; });

								port = undefined;
								console.log(error);
							});
							port = undefined;




						});
					});
				}
		}
	);
}

function flashing() {
  // Клик по кнопке

	if(flashingInProgress) {
		// Это Cancel
		flashingInProgress = false;
		$("#btnConnect").prop('disabled', false);
		$("#port-list").prop('disabled', false);
		$("#btnFlash").html(_i("flash"));
		showToast('success',"flashingcanceled");
		//stk500.
		port.close(function (error) {
			console.log(error.message);
		});

	} else {
		// Это Flash

		flashingInProgress = true;
		$("#btnConnect").prop('disabled', true);
		$("#port-list").prop('disabled', true);
		$("#btnFlash").html(_i("cancel"));

		if(configAlreadyRead) {
			port.write('f\n');
			port.drain();
			try {
				port.close(function (error) {
					console.log("port closed:" + error);
					port.removeAllListeners();
					try {
						//port.options.serial.disconnect(port.connectionId,function (result) { console.log("SMTHWRNG: chrome.serial.disconnect: " + result); port = undefined; });
					} catch(e) { console.log(e) };

					port = undefined;

					console.log("start flashing");
					doFlash();

				})
			} catch(e) { console.log(e) }
		} else {
			doFlash();
		}
	}
}
