

var lastTab;
var serialState = 2;
var writerCurrRegister = 0;
var calibrateFcorr = 0;
var gpsTrack = [];
var longDumpWait = true;


function serialStateMachine (str, num, arr) {

  console.log(serialState + ': "' + str + '"(' + str.length + ')');
  str = str.replace(/(\r\n|\n|\r)/gm,"");
  if(str.length == 0) { return; };
  if(str == "") { return; };
  //str += '\n';

  switch (serialState) {
    case 2: {
      // Начало, только открыли порт, ждем приветствия и засылаем команду для конфигурирования

      if(str.match(/tBeacon...$/)) {
        var regExp = /tBeacon(.)(.)(.)$/g;
        res = regExp.exec(str)
        ver = res[1] + res[2] + res[3];
        if(ver == VERSION) {
          port.write('Beacon\n');
          port.drain();
          console.log("Keyword written");
          //port.write('\n');
        } else {
          var warntext=_i("versionmismatch")+ "\n" + _i("pleaseupdate");

          if(ver+0 > VERSION+0) {
            warntext += _i("theconfigurator");
          } else if(ver+0 < VERSION+0) {
            warntext += _i("thebeacon");
          }
          warntext += "\n" + _i("thebeaconversion") + ver;
          alert(warntext);
        }
      } else if(str.match(/\[CONFIG\]/)) {
        // Маяк должен слить свой конфиг, ждем первого ключевого слова
        serialState = 3;
      }
      break;
    }
    case 3: {
      if(str.match(/R(\d+) = (\d+)/)) {
        // Очередной регистр
        var regExp = /R(\d+) = (\d+)/g;
        while (res = regExp.exec(str)) {
          if(!configAlreadyRead) {
            updateConfig(res[1], res[2]);
          } else {
            updateConfig(res[1], REGS[res[1]].get());
          }
          console.log(res[1] + " : " + res[2]);
        }
        serialState = 3;
      } else if(str.match(/^> $/)) {
      //} else if(str.match(/^> $/)) {
        // Конец регистров
        serialState = 2;
        $("#buzzTestButton").prop('disabled', false);
        if(!configAlreadyRead) {
          updateConfigTab();
          showToast("success","registersread",ver);
          lastTab = $("ul#tabs a.active");
          $("#tabConf").tab('show');
          updateGUI(true);
        };
        configAlreadyRead = true;
      } else {
        comPortDisconnect('Something went wrong (' + serialState + '): ' + str);
        alert('Something went wrong (' + serialState + '): ' + str);
      };
      break;
    }


    case 10: {
      // Начало записи конфига
      writerCurrRegister = 0;
      serialState = 11;
    };
    case 11: {
      // Ожидание приглашения
      if(str.match(/> $/)) {
        serialState++;
        // Записываем номер регистра
        longDumpWait = false;
        port.write(writerCurrRegister + "\n");
        port.drain();
      }
      break;
    };
    case 12: {
      // Ждем приглашения на запись регистра
      if(str.match(/R(\d+) = $/)) {
        longDumpWait = true;
        if(typeof (REGS[writerCurrRegister].get()) !== 'undefined') {
          port.write(REGS[writerCurrRegister].get()+"\n");
        } else {
          port.write(REGS[writerCurrRegister].val+"\n");
        };
        port.drain();
        // Следующий регистр
        writerCurrRegister++;
        if(writerCurrRegister>=REGS_COUNT) {
          // Конец записи
          serialState++;
        } else {
          // Повтор
          serialState--;
        }
      };
      break;
    }
    case 13: {
      // Ожидание приглашения
      if(str.match(/> $/)) {
        serialState = 2;
        // Команда на запись - w
        port.write("w\n");
        port.drain();
      }
      break;
    }



// ----------------------------- Калибровка частоты
    case 20: {
      // Калибровка частоты
      // Ожидание приглашения и запись R0
      if(str.match(/^> $/)) {
        serialState++;
        longDumpWait = true;
        port.write("0\n" + REGS[0].get() + "\n");
        port.drain();
      }
      break;
    };
    case 21: {
      // Ожидание приглашения и запись R1
      if(str.match(/^> $/)) {
        serialState++;
        longDumpWait = true;
        port.write("1\n" + REGS[1].get() + "\n");
        port.drain();
      }
      break;
    }
    case 22: {
      // Ожидание приглашения и старт калибровки
      if(str.match(/^> $/)) {
        serialState++;
        port.write("c\n");
        port.drain();
      }
      break;
    }
    case 23: {
      // Эхо
      if(str.match(/^c$/)) {
      } else if(str.match(/^$/)) {
      } else if(str.match(/^\d+$/)) {
        // Должно быть значение калибровки
        var regExp = /(\d+)/g;
        res = regExp.exec(str);
        console.log(res[1]);
        calibrateFcorr =  res[1];
        serialState=2;
      } else {
        comPortDisconnect(_i("somethingwentwrong") + '(' + serialState + '): ' + str);
      }
      break;
    };



    // ----------------------------- Калибровка пищалки
    case 30: {
      // Ожидание приглашения и запись R19
      if(str.match(/^> $/)) {
        serialState++;
        longDumpWait = true;
        port.write("19\n" + REGS[19].get() + "\n");
        port.drain();
      }
      break;
    };
    case 31: {
      // Ожидание приглашения и вкл пищалки
      if(str.match(/^> $/)) {
        serialState=2;
        longDumpWait = true;
        port.write("b\n");
        port.drain();
      }
      break;
    }




// ----------------------------- Скачивание трека
    case 40: {
      // Ожидание приглашения и запись "t"
      if(str.match(/^> $/)) {
        serialState++;
        longDumpWait = true;
        port.write("t\n");
        port.drain();
      }
      break;
    };
    case 41: {
      if(str.match(/(\d+) (\d+)/)) {
        var regExp = /(\d+) (\d+)/g;
        if (res = regExp.exec(str)) {
          gpsTrack.push({lat: res[1]/10000000, lon: res[2]/10000000});
          console.log('GPS:' + res[1] + ':' + res[2]);
        }
      } else if(str.match(/\[CONFIG\]/)) {
        serialState = 3;
      }
      break;
    };


    // ----------------------------- Вытащить напряжение АКБ

    case 50: {
      // Калибровка напряжения
      // Ожидание приглашения и запись R21
      if(str.match(/^> $/)) {
        serialState++;
        longDumpWait = true;
        port.write("21\n" + REGS[21].get() + "\n");
        port.drain();
      }
      break;
    };
    case 51: {
      // Ожидание приглашения и старт калибровки
      if(str.match(/^> $/)) {
        serialState++;
        port.write("v\n");
        port.drain();
      }
      break;
    }
    case 52: {
      // Эхо
      if(str.match(/^v$/)) {
      } else if(str.match(/^$/)) {
      } else if(str.match(/^\d+$/)) {
        // Должно быть значение калибровки
        var regExp = /(\d+)/g;
        res = regExp.exec(str);
        console.log(res[1]);
        batteryVoltage =  res[1];
        serialState++;
      } else {
        comPortDisconnect(_i("somethingwentwrong") + '(' + serialState + '): ' + str);
      }
      break;
    };
    case 53: {
      // Эхо
      if(str.match(/^c$/)) {
      } else if(str.match(/^$/)) {
      } else if(str.match(/^\d+$/)) {
        // Должно быть значение калибровки
        var regExp = /(\d+)/g;
        res = regExp.exec(str);
        console.log(res[1]);
        externalVoltage =  res[1];
        serialState=2;
        if(serialStateMachineCallback) serialStateMachineCallback(batteryVoltage, externalVoltage);
      } else {
        comPortDisconnect(_i("somethingwentwrong") + '(' + serialState + '): ' + str);
      }
      break;
    };



    default: {
      comPortDisconnect(_i("somethingwentwrong") + '(' + serialState + '): ' + str);
      alert(_i("somethingwentwrong") + '(' + serialState + '): ' + str);
      serialState = 1;
    }

  }
}

var splitstring="";
function serialOnData(data) {
  //console.log(data);
  str = convertArrayBufferToString(data);
  console.log("got str(" + str.length + ")" + str);

  // Склеиваем с тем, что уже в буфере
  splitstring = splitstring + str;
  // Если буффер кончается на "> " или на перевод строки, но можно запускать автомат
  if(
    (splitstring.charAt(splitstring.length - 1) == "\n") ||
    (splitstring.match(/> $/)) ||
    (
      (!longDumpWait) &&
      (splitstring.match(/ R\d+ = $/))
    )
  ) {
    if(CONNECTED) {
      arr = splitstring.split("\n");
      arr.forEach(serialStateMachine);
    } else {
      //alert("smthwrng:" + str);
      console.log("SMTHWRNG: not connected but data on serial: " + str + "/" + splitstring);
    }
    splitstring = "";
  }
};

function reReadConfig() {
  configAlreadyRead = false;
  longDumpWait = true;
  serialState = 2;
  port.write('\n');
  port.drain();
}

function writeConfig() {
  serialState = 10;
  longDumpWait = true;
  port.write('\n');
  port.drain();
}

function calibrateRFM() {
  calibrateFcorr = -1;
  serialState = 20;
  longDumpWait = true;
  port.write('\n');
  port.drain();
}

function buzzerTest() {
  serialState = 30;
  longDumpWait = true;
  port.write('\n');
  port.drain();
}

function voltageCalibrate(callback) {
  serialState = 50;
  longDumpWait = true;
  serialStateMachineCallback = callback;
  port.write('\n');
  port.drain();
}

function fetchGPSTrack() {
  gpsTrack = [];
  serialState = 40;
  port.write('\n');
  port.drain();
}

function resetConfig() {
  configAlreadyRead = false;
  longDumpWait = true;
  serialState = 2;
  port.write('d\n');
  port.drain();
}

function sleep(ms) {
  ms += new Date().getTime();
  while (new Date() < ms){}
}

function comPortDisconnect(str) {

  CONNECTED = false;
  if((port) && (port.isOpen())) {
    port.removeAllListeners();
    port.write('\nq\n');
    port.drain();
    sleep(100);
  };
  try {
    port.close(function() {
      console.log('Device disonnected.');
      if(configAlreadyRead) showToast("none", "devicedisconnected");
      if((port) && (port.connectionId>=0)) {
        port.options.serial.disconnect(port.connectionId,function (result) { console.log("SMTHWRNG: chrome.serial.disconnect: " + result) });
      }
    });
  } catch(e) { console.log(e) }

  port = undefined;
  //delete port;
  if(!lastTab) {
    lastTab = $('#tabAbout');
  }
  updateGUI();

  lastTab.tab('show');
  configAlreadyRead = false;
  killAllModals();
};

function comPortConnect() {
  var curPort="";
	var onConnect = function(err) {
    console.log('Device connected.');
    if (err) {
      //$("#statusbar").html("Error opening serial port " + curPort + ': ' + err.message);
      killAllModals();
      showToast("failure", "erroropeningport", curPort + ': ' + err.message);
      comPortDisconnect();
      return;
    }
    CONNECTED = true;
    showToast("success", "portopened");
		serialState = 2;
    configAlreadyRead = false;

    try {
      port.removeAllListeners();
      port.flush(function () { } );
    } catch(e) { console.log(e) }

    port.on('data', serialOnData);

    //port.drain();
    updateGUI();
  }

  $('#modalProgressTitle').html(_i("t_connectwait"));
  $('#modalProgressText').html(
    _i("waitspinner") +
    '<div class="container">' + _i("m_connectwait") + '</div>'
  );
  $('#modalWCancelButton').off( "click" ); $('#modalWCancelButton').click(function () { comPortDisconnect("Canceled") });
  $('#modalProgress').modal();

  $('#modalProgress').on('shown.bs.modal', function () {
    curPort = $("#port-list").val();
    if((port === undefined) || (port.path != curPort)) {
      CONNECTED = true;
      port = new serialPort.SerialPort(curPort, {
        baudrate: 38400,
        databits: 8,
        parity: "none",
        stopBits: 1,
        bufferSize: 64
      }, true, onConnect);
    } else {
      // Should never happen
      console.log("SMTHWRNG: Should never happen! Port exists!")
      port.options.dataBits = "eight";
      port.options.baudRate = 38400;
      //port.options.serial.update(port.connectionId,port.options,function () {});
      port.removeAllListeners();
      port.on('open', onConnect);
      port.on('data', serialOnData);
    }
  })
}

// Convert string to ArrayBuffer
function convertStringToArrayBuffer(str) {
    var buf = new ArrayBuffer(str.length);
    var bufView = new Uint8Array(buf);
    for (var i = 0; i < str.length; i++) {
        bufView[i] = str.charCodeAt(i);
    }
    return buf;
}

function convertArrayBufferToString(buf) {
    let bufView = new Uint8Array(buf);
    let encodedString = String.fromCharCode.apply(null, bufView);
    return decodeURIComponent(encodedString);
}
